/*
 * Copyright (C) 2020 Weber Yann
 * 
 * This file is part of pyrpn.
 * 
 * pyrpn is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 * 
 * pyrpn is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with pyrpn.  If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef __rpn_ifs__h__
#define __rpn_ifs__h__

#include "config.h"

#include "rpn_jit.h"

/**@defgroup ifs Iterated function system
 * @brief IFS implementation with RPN expressions
 *
 * IFS are basically a list of @ref ifs_if associated with a probability
 * of evaluation.
 *
 * This implementation aims to :
 * - optimize @ref ifs_if calls
 * - optimize random number generation and IF random calls
 * 
 * @note It aims to provide an API close to @ref ifs_if API, in order to
 * be able to use both IFS and IF almost tansparently via Python API.
 */

#endif

